package VerifyTemplate

import (
	"ColdVerify_server/lib"
	"ColdVerify_server/logs"
	"fmt"
	"github.com/beego/beego/v2/adapter/orm"
	orm2 "github.com/beego/beego/v2/client/orm"
	_ "github.com/go-sql-driver/mysql"
	"time"
)

// 模板
type VerifyTemplate struct {
	Id      int `orm:"column(ID);size(11);auto;pk"`
	T_class int `orm:"size(8);default(0)"` // 分类

	T_VerifyTemplate_id string `orm:"size(256);null"`     // 标题
	T_name              string `orm:"size(256);null"`     // 标题
	T_sort              int    `orm:"size(2);default(1)"` // 排

	T_scheme    string `orm:"size(256);null"` // 方案模板
	T_reporting string `orm:"size(256);null"` // 报告模板

	CreateTime time.Time `orm:"column(create_time);type(timestamp);null;auto_now_add"` //auto_now_add 第一次保存时才设置时间
	UpdateTime time.Time `orm:"column(update_time);type(timestamp);null;auto_now"`     //auto_now 每次 model 保存时都会对时间自动更新
}

type VerifyTemplate_R struct {
	T_VerifyTemplate_id string `orm:"size(256);null"` // 标题
	T_name              string `orm:"size(256);null"` // 标题
	T_sort              int    `orm:"size(200);null"` // 分类

	T_scheme    string // 方案模板
	T_reporting string // 报告模板
}

func (t *VerifyTemplate) TableName() string {
	return "verify_template" // 数据库名称   // ************** 替换 FormulaList **************
}

func init() {

	//注册模型
	orm.RegisterModel(new(VerifyTemplate))

}

// -------------------------------------------------------------
func VerifyTemplateToVerifyTemplate_R(T VerifyTemplate) (T_r VerifyTemplate_R) {
	T_r.T_VerifyTemplate_id = T.T_VerifyTemplate_id
	T_r.T_name = T.T_name
	T_r.T_sort = T.T_sort
	T_r.T_scheme = T.T_scheme
	T_r.T_reporting = T.T_reporting

	return T_r
}

// ---------------- 特殊方法 -------------------

// 获取 ById
func Read_VerifyTemplate_ById(id int) (r VerifyTemplate, is bool) {
	o := orm.NewOrm()
	r = VerifyTemplate{Id: id}
	err := o.Read(&r) // o.Read(&r,"Tokey") 如果不是 主键 就得指定字段名
	if err != nil {
		logs.Error(lib.FuncName(), err)
		return r, false
	}
	return r, true
}

// 获取 By
func Read_VerifyTemplate(T_VerifyTemplate_id string) (r VerifyTemplate, is bool) {

	o := orm.NewOrm()
	qs := o.QueryTable(new(VerifyTemplate))
	err := qs.Filter("T_VerifyTemplate_id", T_VerifyTemplate_id).One(&r)
	if err != nil {
		return r, false
	}

	return r, true
}

func Read_VerifyTemplate_T_name(T_name string) (r VerifyTemplate, is bool) {

	o := orm.NewOrm()
	qs := o.QueryTable(new(VerifyTemplate))
	err := qs.Filter("T_name", T_name).One(&r)
	if err != nil {
		return r, false
	}

	return r, true
}

// 添加
func Add_VerifyTemplate(r VerifyTemplate) (T_VerifyTemplate_id string, is bool) {
	o := orm.NewOrm()

	// 生成编号
	rand_x := 0
	for true {
		r.T_VerifyTemplate_id = lib.GetRandstring(4, "", int64(rand_x)) // 1,336,336
		err := o.Read(&r, "T_VerifyTemplate_id")                        // o.Read(&r,"Tokey") 如果不是 主键 就得指定字段名
		if err != nil {
			break
		}
		rand_x += 1
	}

	_, err := o.Insert(&r)
	if err != nil {
		logs.Error(lib.FuncName(), err)
		return "", false
	}

	return r.T_VerifyTemplate_id, true
}

// 删除
func Delete_VerifyTemplate(v VerifyTemplate) bool {
	o := orm.NewOrm()
	if num, err := o.Delete(&v); err == nil {
		logs.Println("Number of records deleted in database:", num)
	} else {
		return false
	}

	return true
}

// 修改
func Update_VerifyTemplate(m VerifyTemplate, cols ...string) bool {
	o := orm.NewOrm()
	if num, err := o.Update(&m, cols...); err == nil {
		fmt.Println("Number of records updated in database:", num)
		return true
	}
	return false
}

// 获取列表
func Read_VerifyTemplate_List(T_class int, T_name string, page int, page_z int) ([]VerifyTemplate_R, int64) {

	o := orm.NewOrm()
	// 也可以直接使用 Model 结构体作为表名
	var r []VerifyTemplate
	qs := o.QueryTable(new(VerifyTemplate))
	var offset int64
	if page <= 1 {
		offset = 0
	} else {
		offset = int64((page - 1) * page_z)
	}

	cond := orm.NewCondition()
	cond1 := cond.And("T_class", T_class).And("T_name__icontains", T_name) // .AndNot("status__in", 1).Or("profile__age__gt", 2000)

	qs.Limit(page_z, offset).SetCond((*orm2.Condition)(cond1)).OrderBy("T_name").All(&r)
	cnt, _ := qs.SetCond((*orm2.Condition)(cond1)).Count()
	// 转换
	var VerifyTemplate_r []VerifyTemplate_R
	for _, v := range r {
		VerifyTemplate_r = append(VerifyTemplate_r, VerifyTemplateToVerifyTemplate_R(v))
	}

	return VerifyTemplate_r, cnt
}
